module DecentExposure
  def inherited(klass)
    closured_exposure = default_exposure
    klass.class_eval do
      default_exposure(&closured_exposure)
    end
  end

  def default_exposure(&block)
    @default_exposure = block if block_given?
    @default_exposure
  end

  def expose(name, &block)
    closured_exposure = default_exposure
    define_method name do
      @_resources       ||= {}
      @_resources[name] ||= if block_given?
        instance_eval(&block)
      else
        instance_exec(name, &closured_exposure)
      end
    end
    helper_method name
    hide_action name
  end
  alias let expose
end
